module C = Common

type var = Ix of int

type 'a binder = B of 'a

type term 
  = Var  of var
  | Meta of C.meta
  | InsMeta of C.meta * int (* amount of things bound in ctx : int *)

  | Type

  | T0
  | Ind0 of term binder * term

  | T1
  | T1tr (* Unit eta rule instead of elimination principle *)

  | TNat
  | Zero
  | Suc  of term
  | IndN of term binder * term * term binder binder * term

  | TBool
  | True
  | False
  | IndB of term binder * term * term * term (* ordered true, false *)

  | Pi   of C.icit * term * term binder
  | Lam  of C.icit * term binder
  | App  of C.icit * term * term

  | Sg   of term * term binder
  | Pair of term * term
  | Fst  of term
  | Snd  of term

  | Let  of term * term * term binder (* tr : ty in sc *)
